#include "kernel32.as"

#module

#ifndef UART_COM_HSP_ // d`h~̂
#define UART_COM_HSP_ // d`h~̂

#define NULL                       0
#define OPEN_EXISTING              3
#define GENERIC_READ               0x80000000
#define GENERIC_WRITE              0x40000000
#define FILE_ATTRIBUTE_NORMAL      0x00000080
#define INVALID_HANDLE_VALUE       0xffffffff
#define MAXDWORD                   0xffffffff
#define SETDTR                     5
#define CLRDTR                     6

;#define comopen(%1, %2="") comopen_ %1, %2
#deffunc comopen_v2 int _port, str _proto
	if _port > 0 {
		path = "\\\\.\\COM" + _port
	} else {
		path = "LPT1"
	}

	CreateFileA path, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	comHandle = stat
	logmes "comHandle = " + comHandle
	if comHandle == INVALID_HANDLE_VALUE : return -1

	dim dcb, 7
	GetCommState comHandle, varptr(dcb)
	if stat == 0 : return -1

	if strlen(_proto) > 0 {
		BuildCommDCB _proto, varptr(dcb)
		if stat == 0 : return 3
	}

	SetCommState comHandle, varptr(dcb)
	if stat == 0 : return -1

	dim timeouts, 5
	timeouts(0) = MAXDWORD
	timeouts(1) = 0
	timeouts(2) = 0
	timeouts(3) = 0
	timeouts(4) = 0
	SetCommTimeouts comHandle, varptr(timeouts)

	EscapeCommFunction comHandle, SETDTR
	return 0

#deffunc comclose_v2
	EscapeCommFunction comHandle, CLRDTR
	CloseHandle comHandle
	comHandle = NULL
	return 0

#deffunc comput_v2 str _s
	numWritten = 0
	WriteFile comHandle, _s, strlen(_s), varptr(numWritten), 0
	if stat == 0 : return 0
	return numWritten

#deffunc computc_v2 int _byte
	sdim sd, 4
	numWritten = 0
	poke sd, 0, _byte
	WriteFile comHandle, sd, 1, varptr(numWritten), 0
	if stat == 0 : return 0
	return numWritten

#deffunc computb_v2 var v, int _size
	numWritten = 0
	WriteFile comHandle, varptr(v), _size, varptr(numWritten), 0
	if stat == 0 : return 0
	return numWritten

#deffunc comget_v2 var v, int _size
	sdim v, _size + 1
	numRead = 0
	if _size == 0 : size = 64 : else : size = _size
	ReadFile comHandle, varptr(v), size, varptr(numRead), 0
	if stat == 0 {
		v = ""
		return 0
	}
	poke v, numRead, 0
	return numRead

#deffunc comgetc_v2 var v
	numRead = 0
	sdim buf, 10
	ReadFile comHandle, varptr(buf), 1, varptr(numRead), 0
	v = peek(buf, 0)
	return numRead

#deffunc comcontrol_v2 int _fn
	EscapeCommFunction comHandle, _fn
	if stat == 0 : return -1
	return 0

#deffunc comstat_v2 var v
	dim v, 4
	ClearCommError comHandle, varptr(v), varptr(v) + 4
	if stat == 0 : return -1
	return 0

#deffunc commodemstat_v2 var v
	GetCommModemStatus comHandle, varptr(v)
	if stat == 0 : return -1
	return 0

#global